global function FactionLockInit
global function SaveFactionStatus
global function RestoreFaction
global function ChangeFaction
global function RestoreBurnCard
global function ChangeBurnCard
global function RestoreAll
global function RestoreLoadout
global function ChangeLoadout


struct {
    string currentFaction
    int currentPilotLoadoutIndex
    int currentTitanLoadoutIndex
    string currentBurncard
} file


void function FactionLockInit(){
    thread Monitor()
}

void function SaveFactionStatus() {
    entity player = GetLocalClientPlayer()
    file.currentFaction = GetFactionChoice( player )
    file.currentPilotLoadoutIndex = GetPersistentSpawnLoadoutIndex( player, "pilot" )
    file.currentTitanLoadoutIndex = GetPersistentSpawnLoadoutIndex( player, "titan" )
    // file.currentBurncardIndex = expect int ( player.GetPersistentVar( "burnmeterSlot" ) )
    file.currentBurncard = GetSelectedBurnCardRef(player)
}

void function RestoreAll() {
    RestoreLoadout()
    RestoreFaction()
    RestoreBurnCard()
}

void function RestoreLoadout()
{
    ChangeLoadout(file.currentPilotLoadoutIndex, file.currentTitanLoadoutIndex)
}

void function RestoreFaction()
{
    ChangeFaction(file.currentFaction)
}

void function RestoreBurnCard()
{
    ChangeBurnCard(file.currentBurncard)
}

void function ChangeLoadout(int pilot, int titan) {
    entity player = GetLocalViewPlayer()
    if (player != null) {

        RunUIScript("UpdateLoadoutUI", pilot, titan)

        player.ClientCommand( "RequestPilotLoadout " + pilot )
        player.ClientCommand( "RequestTitanLoadout " + titan )
    }
}



void function ChangeFaction(string factionRef) {
    if (factionRef != "null" && factionRef != "") {
        entity player = GetLocalViewPlayer()
        if (player != null) {
            player.ClientCommand( "SetFactionChoicePersistenceSlot " + factionRef )
        }
    }
}


void function ChangeBurnCard(string ref) {
    if (ref != "null" && ref != "") {
        entity player = GetLocalViewPlayer()
        if (player != null) {
            player.ClientCommand( "SetBurnCardPersistenceSlot " + ref )
        }
    }
}
void function Monitor(){
    WaitFrame()
    while(!IsLobby())
    {
        WaitFrame()

    }

    SaveFactionStatus()
    PrintCurrent()
}

void function PrintCurrent() {
    printl("currentFaction "+file.currentFaction)
    printl("currentPilotLoadoutIndex "+file.currentPilotLoadoutIndex)
    printl("currentTitanLoadoutIndex "+file.currentTitanLoadoutIndex)

    // printl("currentBurncardIndex "+file.currentBurncardIndex)
    // BurnReward burnCard = burn.allCards[ file.currentBurncardIndex ]
	// string ref = burnCard.ref
    // string ref = GetSelectedBurnCardRef(GetLocalClientPlayer())
    printl("currentBurncardBurnReward "+file.currentBurncard)

}
